//	ScreamingSnakeballGlobalData.cpp - The game's global data.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "ScreamingSnakeballGlobalData.h"

//------------------------------------------------------------------------------
ScreamingSnakeballGlobalData::ScreamingSnakeballGlobalData():
screenShake(0.1f),
backgroundFlash(0.0f),
borderFlash(1.0f),
matchLength(5.0f),
audioAPI(L""),
audioInputDevice(0),
redInputChannel(0),
blueInputChannel(0),
whispering(false),
shouting(false)
{
	int tempint;
	float tempf;
	std::wstring tempstr;

	tempf = optionsFile.getOptionFloat(L"screenShake");
	if(tempf > -1.0f)
		screenShake = tempf;
	tempf = optionsFile.getOptionFloat(L"backgroundFlash");
	if(tempf > -1.0f)
		backgroundFlash = tempf;
	tempf = optionsFile.getOptionFloat(L"borderFlash");
	if(tempf > -1.0f)
		borderFlash = tempf;
	tempf = optionsFile.getOptionFloat(L"matchLength");
	if(tempf > -1.0f)
		matchLength = tempf;
	audioAPI = optionsFile.getOptionString(L"audioAPI");
	tempint = optionsFile.getOptionInt(L"audioInputDevice");
	if(tempint > -1)
		audioInputDevice = tempint;
	tempint = optionsFile.getOptionInt(L"redInputChannel");
	if(tempint > -1)
		redInputChannel = tempint;
	tempint = optionsFile.getOptionInt(L"blueInputChannel");
	if(tempint > -1)
		blueInputChannel = tempint;
}

//------------------------------------------------------------------------------
ScreamingSnakeballGlobalData::~ScreamingSnakeballGlobalData()
{

}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setScreenShake(float val)
{
	screenShake = val;
	optionsFile.setOption(L"screenShake", screenShake);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setBackgroundFlash(float val)
{
	backgroundFlash = val;
	optionsFile.setOption(L"backgroundFlash", backgroundFlash);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setBorderFlash(float val)
{
	borderFlash = val;
	optionsFile.setOption(L"borderFlash", borderFlash);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setMatchLength(float val)
{
	matchLength = val;
	optionsFile.setOption(L"matchLength", matchLength);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setAudioAPI(const std::wstring& val)
{
	audioAPI = val;
	optionsFile.setOption(L"audioAPI", audioAPI);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setAudioInputDevice(int val)
{
	audioInputDevice = val;
	optionsFile.setOption(L"audioInputDevice", audioInputDevice);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setRedInputChannel(int val)
{
	redInputChannel = val;
	optionsFile.setOption(L"redInputChannel", redInputChannel);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setBlueInputChannel(int val)
{
	blueInputChannel = val;
	optionsFile.setOption(L"blueInputChannel", blueInputChannel);
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setWhispering(bool val)
{
	whispering = val;
}

//------------------------------------------------------------------------------
void ScreamingSnakeballGlobalData::setShouting(bool val)
{
	shouting = val;
}
