//	Wall.cpp - The wall class.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "Wall.h"

//------------------------------------------------------------------------------
Wall::Wall(const TwoFloats& pos, const std::wstring& realName):
Collidable(realName),
position(pos),
radius(18.0f)
{
	
}

//------------------------------------------------------------------------------
Wall::~Wall()
{

}

//------------------------------------------------------------------------------
void Wall::setPosition(const TwoFloats& pos)
{
	position = pos;
}

//------------------------------------------------------------------------------
void Wall::setRadius(float val)
{
	radius = val;
}

//------------------------------------------------------------------------------
bool Wall::interestedInCollisionsWith(const std::wstring& entity) const
{
	return (entity != L"Wall");
}

//------------------------------------------------------------------------------
bool Wall::collide(const shared_ptr<Collidable>& other,
				   GamePlayState& state)
{
	if(other->getName() == L"Ball")
		return true;
	else
		return false;
}
